name_list = ['Alice', 'Bob', 'Cynthia', 'Derek', 'Eustace', 'Francis', 'Gregg']

for name in name_list:
    print(name)

for loc, name in enumerate(name_list):
    print(loc, name)

for ltr in 'Hello Paradigms':
    print(ltr)

x, y, *z = name_list
print(x)
print(y)
print(z)

x, *y, z = name_list
print(x)
print(y)
print(z)

x, *_, z = name_list
print(x)
print(z)


l = [print(name) for name in name_list]
print(l)

l = [(loc, name) for loc, name in enumerate(name_list)]
print(l)

l = [i for i in range(0, 5)]
print(l)

l = list(range(0, 5))
print(l)

l = [i * 2 for i in range(0, 5)]
print(l)

l = filter(lambda x: x % 2 == 0, range(0, 10))
print(l)
print(list(l))

l = [i for i in range(0, 10) if i % 2 == 0]
print(l)

l = map(lambda x: x * x, range(0,10))
print(l)
print(list(l))

l = [x * x for x in range(0,10)]
print(l)

l = [i * 2 if i % 2 == 0 else 'Odd' for i in range(0, 5)]
print(l)

num_list=[[1,2,3],[4,5,6],[7,8,9]]
l = [num for inner_list in num_list for num in inner_list]
print(l)

l = [[n for n in range(10) if n %2==0] for i in range(3)]
print(l)

num_list = [1, 2, 1, 3, 7, 5, 6, 4, 2]
s = {i * 2 for i in num_list}
print(s)

d = {loc:name for loc, name in enumerate(name_list)}
print(d)

d = {loc:num for loc, num in enumerate([i * 2 if i % 2 == 0 else 'Odd' for i in range(0, 5)])}

print(d)

g = (name.upper() for name in name_list)
print(g)
print(list(g))

g = (name.upper() for name in name_list)
for name in g:
    print(name)

print(g)
print(list(g))

def my_gen():
    for i in name_list:
        yield i.upper()

for i in my_gen():
    print(i)

name_gen = my_gen()
print(name_gen)

while True:
    try:
        print(next(name_gen))
    except StopIteration as e:
        break

def my_gen():
    return (i.upper() for i in name_list)

name_gen = my_gen()
print(name_gen)
while my_gen():
    print(next(name_gen))